# Testing this charm

Testing this charm is done at two levels: unit tests and functional tests.

## Unit testing

Unit testing will run pure-python unit tests on the local code. It can be done
with "make test".

## Functional testing

Functional testing is a little more involved, as the charm will be deployed in
a juju environment for real, and will be tested against using Amulet.

To run functional tests, you need to run "make functional_test". The necessary
dependencies will be added to your environment, namely a new PPA will be added
and a few debian packages will be installed.

It is recommended to run functional tests from within a container (LXD).

Running the tests require that you pass a JUJU_ENV=xxx environment variable where
xxx is the name of the environment the test suite will use to test. The
environment should not already be bootstraped, and should be a Juju 1.25
environment.

The test suite uses a lot of IO, so it is recommended to use a cloud with decent
IO performances (EC2 is suggested).
